<script setup lang="ts">
import type { OrderReceipt, status } from '@/types/OrderReceipt'
import type { OrderReceiptItem } from '@/types/OrderReceiptItem'
import { computed, nextTick, ref } from 'vue'
import { onMounted } from 'vue'
import type { VForm } from 'vuetify/components'

const orderReceipts = ref<OrderReceipt>({
  id: -1,
  orderDate: new Date(),
  receiveDate: new Date(),
  totalQty: 0,
  totalPrice: 0,
  statusOrder: ['waiting for shipment']
})

const orderReceiptsTable = ref<OrderReceipt[]>([])
const headers = [
  {
    title: 'Id',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Order Date',
    key: 'orderDate',
    value: 'orderDate'
  },
  {
    title: 'Receive Date',
    key: 'receiveDate',
    value: 'receiveDate'
  },
  {
    title: 'Total Qty',
    key: 'totalQty',
    value: 'totalQty'
  },
  {
    title: 'Total Price',
    key: 'totalPrice',
    value: (item: OrderReceipt) => item.totalPrice.toFixed(2)
  },
  {
    title: 'Status Order',
    key: 'statusOrder',
    value: (item: any | status) => item.statusOrder.join(', ')
  },

  { title: '', key: 'actions', sortable: false }
]

const orderReceiptItems = ref<OrderReceiptItem[]>([])

function initializeOrderStockTable() {
  orderReceiptsTable.value = [
    {
      id: 1,
      orderDate: new Date('2024-01-03'),
      receiveDate: new Date('2024-01-06'),
      totalQty: 90,
      totalPrice: 15110,
      statusOrder: ['delivered'],
      orderReceiptItem: [
        {
          id: -1,
          name: 'Coffee Beans',
          price: 7560,
          qty: 40
        },
        {
          id: -1,
          name: 'Whipped Cream',
          price: 3750,
          qty: 30
        },
        {
          id: -1,
          name: '	Syrup',
          price: 3800,
          qty: 20
        }
      ]
    },
    {
      id: 2,
      orderDate: new Date('2024-03-05'),
      receiveDate: new Date('2024-03-08'),
      totalQty: 50,
      totalPrice: 2255,
      statusOrder: ['delivered'],
      orderReceiptItem: [
        {
          id: -1,
          name: 'Green tea powder',
          price: 730,
          qty: 10
        },
        {
          id: -1,
          name: 'Dough',
          price: 495,
          qty: 15
        },
        {
          id: -1,
          name: '	Honey',
          price: 570,
          qty: 15
        },
        {
          id: -1,
          name: '	Sugar',
          price: 460,
          qty: 10
        }
      ]
    },
    {
      id: 3,
      orderDate: new Date('2024-06-20'),
      receiveDate: new Date('2024-06-25'),
      totalQty: 80,
      totalPrice: 2665,
      statusOrder: ['waiting for shipment'],
      orderReceiptItem: [
        {
          id: -1,
          name: 'Milk',
          price: 1110,
          qty: 30
        },
        {
          id: -1,
          name: 'Condensed Milk',
          price: 945,
          qty: 35
        },
        {
          id: -1,
          name: '	Honey',
          price: 380,
          qty: 10
        },
        {
          id: -1,
          name: '	Sugar',
          price: 230,
          qty: 5
        }
      ]
    }
  ]
}
onMounted(() => {
  initializeOrderStockTable()
})

const initialOrderReceipt: OrderReceipt = {
  id: -1,
  orderDate: new Date(),
  receiveDate: new Date(),
  totalQty: 0,
  totalPrice: 0,
  statusOrder: ['waiting for shipment']
}

const initialOrderReceiptItems: OrderReceiptItem = {
  id: -1,
  name: '',
  price: 0,
  qty: 0
}

const page = ref(1)
const itemsPerPage = ref<any>(8)
const editedOrderReceiptItem = ref<OrderReceiptItem>(
  JSON.parse(JSON.stringify(initialOrderReceiptItems))
)
const editedOrderReceipt = ref<OrderReceipt>(JSON.parse(JSON.stringify(initialOrderReceipt)))
const search = ref('')
const dialog = ref(false)
const dialogDelete = ref(false)
const dialogEdited = ref(false)
const refForm = ref<VForm | null>(null)
const form = ref(false)
const loading = ref(false)
const divOrderReceiptItems = ref<HTMLElement | null>(null)
const dialogShowOrderReceiptItems = ref(false)
const dialogReceiveOrder = ref(false)
const isOpenOrderDate = ref(false)
const isOpenReceiveDate = ref(false)
let editedIndex = -1
let lastId = 4
const pageCount = computed(() => {
  return Math.ceil(orderReceiptsTable.value.length / itemsPerPage.value)
})
const filteredOrderStock = computed(() => {
  return orderReceiptsTable.value.filter(
    (orderReceiptsTable) =>
      orderReceiptsTable.orderDate?.toLocaleDateString().includes(search.value)
  )
})

function onSubmit() {}

function closeDialog() {
  dialog.value = false
  dialogShowOrderReceiptItems.value = false
  dialogEdited.value = false
  nextTick(() => {
    editedOrderReceipt.value = Object.assign({}, initialOrderReceipt)
    editedIndex = -1
  })
  clearOrderReceipt()
  clearReceiptItems()
}

async function addReceiptItems() {
  const { valid } = await refForm.value!.validate()

  if (!valid) return
  const newOrderReceipt: OrderReceiptItem = {
    id: -1,
    name: editedOrderReceiptItem.value.name,
    price: editedOrderReceiptItem.value.price,
    qty: editedOrderReceiptItem.value.qty
  }

  for (const item of orderReceiptItems.value) {
    if (item.name.toUpperCase() === editedOrderReceiptItem.value.name.toUpperCase()) return
  }
  orderReceiptItems.value.push(newOrderReceipt)
  clearReceiptItems()
  calculate()
  nextTick(() => {
    if (divOrderReceiptItems.value)
      divOrderReceiptItems.value.scrollTo(0, divOrderReceiptItems.value.scrollHeight)
  })
}

function cancelItems() {
  editedOrderReceiptItem.value.id = -1
  editedOrderReceiptItem.value.name = ''
  editedOrderReceiptItem.value.price = 0
  editedOrderReceiptItem.value.qty = 0
}

function clearReceiptItems() {
  editedOrderReceiptItem.value.id = -1
  editedOrderReceiptItem.value.name = ''
  editedOrderReceiptItem.value.price = 0
  editedOrderReceiptItem.value.qty = 0
}

function calculate() {
  let totalPrice = 0
  for (const item of orderReceiptItems.value) {
    totalPrice += item.price
  }
  let totalQty = 0
  for (const item of orderReceiptItems.value) {
    totalQty += item.qty
  }
  orderReceipts.value.totalQty = totalQty
  orderReceipts.value.totalPrice = totalPrice
}

function save() {
  if (editedIndex > -1) {
    Object.assign(orderReceiptsTable.value[editedIndex], editedOrderReceipt.value)
  } else {
    if (orderReceipts.value.totalQty === 0) {
      return
    }
    orderReceipts.value.orderReceiptItem = orderReceiptItems.value
    orderReceipts.value.id = lastId++
    orderReceiptsTable.value.push(orderReceipts.value)
  }
  clearOrderReceipt()
  closeDialog()
}

function editedOrderReceiptDialog(item: OrderReceipt) {
  editedIndex = orderReceiptsTable.value.indexOf(item)
  editedOrderReceipt.value = Object.assign({}, item)
  dialogEdited.value = true
}

function clearOrderReceipt() {
  orderReceiptItems.value = []
  orderReceipts.value = {
    id: -1,
    orderDate: new Date(),
    receiveDate: new Date(),
    totalQty: 0,
    totalPrice: 0,
    statusOrder: ['waiting for shipment']
  }
}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedOrderReceipt.value = Object.assign({}, initialOrderReceipt)
  })
}
function deleteItemConfirm() {
  //  Delete item from list
  orderReceiptsTable.value.splice(editedIndex, 1)
  closeDelete()
  editedIndex = -1
}
function deleteItem(item: OrderReceipt) {
  editedIndex = orderReceiptsTable.value.indexOf(item)
  editedOrderReceipt.value = Object.assign({}, item)
  dialogDelete.value = true
}

function showOrderReceiptItems(item: OrderReceipt) {
  editedIndex = orderReceiptsTable.value.indexOf(item)
  editedOrderReceipt.value = Object.assign({}, item)
  dialogShowOrderReceiptItems.value = true
}

function removeOrderReceiptItems(orderReceiptItem: OrderReceiptItem) {
  const index = orderReceiptItems.value.findIndex((item) => item === orderReceiptItem)
  orderReceiptItems.value.splice(index, 1)
  calculate()
}

function orderStockReceiveConfirm() {
  if (editedOrderReceipt.value.statusOrder.includes('delivered')) {
    return
  }
  editedOrderReceipt.value.receiveDate = new Date()
  editedOrderReceipt.value.statusOrder = ['delivered']
  Object.assign(orderReceiptsTable.value[editedIndex], editedOrderReceipt.value)
  closeReceiveOrderConfirm()
  editedIndex = -1
}

function getColorStatusOrder(status: status) {
  if (status === 'delivered') {
    return 'green'
  } else {
    return 'red'
  }
}

function closeReceiveOrderConfirm() {
  dialogReceiveOrder.value = false
  nextTick(() => {
    editedOrderReceipt.value = Object.assign({}, initialOrderReceipt)
  })
}

function receiveOrder(item: OrderReceipt) {
  editedIndex = orderReceiptsTable.value.indexOf(item)
  editedOrderReceipt.value = Object.assign({}, item)
  dialogReceiveOrder.value = true
}
</script>

<template>
  <div>
    <h1 style="text-align: left" class="ml-5 mt-5">
      <v-icon icon="mdi-truck-delivery"></v-icon>&nbsp;ORDER STOCK
    </h1>
    <v-card-title class="d-flex align-center pe-2 font">
      <v-spacer></v-spacer>
      <!-- ปุ่มSearch -->
      <v-text-field
        v-model="search"
        prepend-inner-icon="mdi-magnify"
        density="compact"
        label="Search"
        single-line
        flat
        hide-details
        variant="solo-filled"
      ></v-text-field>
      <!--orderReceipt Dialog-->
      <v-dialog v-model="dialog" persistent width="900" height="800">
        <template v-slot:activator="{ props }">
          <v-btn
            color="brown-lighten-2"
            variant="flat"
            style="width: 200px; height: 40px"
            v-bind="props"
          >
            <v-icon icon="mdi-plus"></v-icon>
            New OrderReceipt
          </v-btn>
        </template>
        <v-card>
          <v-card-title class="mt-3">
            <span class="font" style="font-size: 35px">Receipt Items</span>
          </v-card-title>
          <v-card-text>
            <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
              <v-container>
                <v-row>
                  <v-col cols="12" sm="12" md="4">
                    <v-text-field
                      v-model="editedOrderReceiptItem.name"
                      :readonly="loading"
                      :rules="[(v) => !!v || 'Field is required']"
                      class="mb-2"
                      clearable
                      label="Name"
                      variant="outlined"
                      placeholder="Enter your Item Name"
                    ></v-text-field>
                  </v-col>
                  <v-col cols="12" sm="12" md="4">
                    <v-text-field
                      v-model.number="editedOrderReceiptItem.qty"
                      :readonly="loading"
                      :rules="[(v) => !/[^0-9]/g.test(v), (v) => !!v]"
                      class="mb-2"
                      clearable
                      label="Qauntity"
                      variant="outlined"
                      placeholder="Enter your QTY"
                    ></v-text-field>
                  </v-col>
                  <v-col cols="12" sm="12" md="4">
                    <v-text-field
                      v-model.number="editedOrderReceiptItem.price"
                      variant="outlined"
                      :readonly="loading"
                      :rules="[(v) => !/[^0-9]/g.test(v), (v) => !!v]"
                      clearable
                      label="Price"
                      placeholder="Enter your Price"
                    ></v-text-field>
                  </v-col>
                </v-row>
              </v-container>

              <v-card-actions aria-label="right">
                <v-btn
                  color="green"
                  variant="flat"
                  style="width: 150px; height: 50px"
                  @click="addReceiptItems"
                  >ADD</v-btn
                >
                <v-btn
                  color="red"
                  variant="flat"
                  style="width: 150px; height: 50px"
                  @click="cancelItems"
                  >Cancel</v-btn
                >
              </v-card-actions>
            </v-form>
            <div ref="divOrderReceiptItems" style="height: 400; overflow: auto">
              <v-sheet min-width="400" max-width="1340" height="400" elevation="4">
                <v-table>
                  <template v-slot:default>
                    <thead class="font">
                      <tr>
                        <th></th>
                        <th>#</th>
                        <th></th>
                        <th>Name</th>
                        <th></th>
                        <th>Quantity</th>
                        <th></th>
                        <th>Price</th>
                        <th></th>
                      </tr>
                    </thead>
                    <tbody>
                      <tr v-for="(item, index) of orderReceiptItems" :key="item.id" class="font">
                        <td></td>
                        <td>{{ index + 1 }}</td>
                        <td></td>
                        <td>{{ item.name }}</td>
                        <td></td>
                        <td>{{ item.qty }}</td>
                        <td></td>
                        <td>{{ item.price.toFixed(2) }}</td>
                        <td>
                          <v-btn
                            icon="mdi-delete"
                            density="compact"
                            @click="
                              () => {
                                removeOrderReceiptItems(item)
                              }
                            "
                          ></v-btn>
                        </td>
                      </tr>
                    </tbody>
                  </template>
                </v-table>
              </v-sheet>
            </div>
          </v-card-text>

          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn
              color="red"
              variant="flat"
              style="width: 150px; height: 50px"
              @click="closeDialog"
              >Close</v-btn
            >
            <v-btn color="green" variant="flat" style="width: 150px; height: 50px" @click="save"
              >Save</v-btn
            >
          </v-card-actions>
        </v-card>
      </v-dialog>
    </v-card-title>

    <!-- table -->
    <v-data-table
      v-model:page="page"
      :headers="headers as any"
      :items="filteredOrderStock"
      :items-per-page="itemsPerPage"
    >
      <template v-slot:bottom>
        <div class="text-center pt-2">
          <v-pagination v-model="page" :length="pageCount"></v-pagination>
        </div>
      </template>

      <template v-slot:[`item.orderDate`]="{ value }">
        {{ value.toLocaleDateString('en-GB') }}
      </template>
      <template v-slot:[`item.receiveDate`]="{ value }">
        {{ value.toLocaleDateString('en-GB') }}
      </template>
      <template v-slot:[`item.statusOrder`]="{ value }">
        <div class="text-start">
          <v-chip :color="getColorStatusOrder(value)" class="text-uppercase" label size="small">
            {{ value }}
          </v-chip>
        </div>
      </template>

      <!-- ปุ่มAction -->
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="receiveOrder(item)">mdi-truck-delivery</v-icon>
        <v-icon size="small" class="me-2" @click="editedOrderReceiptDialog(item)"
          >mdi-pencil</v-icon
        >
        <v-icon size="small" class="me-2" @click="showOrderReceiptItems(item)">
          mdi-receipt-text</v-icon
        >
        <v-icon size="small" class="me-2" @click="deleteItem(item)"> mdi-delete</v-icon>
      </template>
    </v-data-table>

    <!-- showOrderReceiptItems -->
    <v-dialog v-model="dialogShowOrderReceiptItems" style="width: 700px" persistent>
      <v-card style="height: 400px">
        <v-card-title style="font-size: 25px">OrderReceipt Item </v-card-title>

        <v-card-text>
          <v-table style="height: 400px">
            <v-row>
              <v-spacer></v-spacer>
              <v-col cols="1">#</v-col>
              <v-spacer></v-spacer>
              <v-col cols="3">Name</v-col>
              <v-spacer></v-spacer>
              <v-col cols="3">Quantity(Unit)</v-col>
              <v-spacer></v-spacer>
              <v-col cols="2">Price(Bath)</v-col>
              <v-spacer></v-spacer>
            </v-row>
            <v-row v-for="(item, index) of editedOrderReceipt.orderReceiptItem" :key="item.id">
              <v-spacer></v-spacer>
              <v-col cols="1">{{ index + 1 }}</v-col>
              <v-spacer></v-spacer>
              <v-col cols="3">{{ item.name }}</v-col>
              <v-spacer></v-spacer>
              <v-col cols="3">{{ item.qty }}</v-col>
              <v-spacer></v-spacer>
              <v-col cols="2">{{ item.price.toFixed(2) }}</v-col>
              <v-spacer></v-spacer>
            </v-row>
            <v-row>
              <v-col></v-col>
            </v-row>
            <v-row>
              <div class="text-right">
                <v-btn
                  color="red"
                  style="width: 120px; height: 50px"
                  variant="flat"
                  class="ms-8"
                  @click="closeDialog()"
                  >Close</v-btn
                >
              </div>
            </v-row>
          </v-table>
        </v-card-text>
      </v-card>
    </v-dialog>

    <!-- dialog editedDate -->
    <v-dialog v-model="dialogEdited" persistent width="450">
      <v-card>
        <v-card-title style="font-size: 30px" class="mt-3">
          <span class="font">Order Receipt Date</span>
        </v-card-title>
        <v-card-text>
          <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit" class="font">
            <div style="width: 90%">
              <v-container>
                <v-menu v-model="isOpenOrderDate" :close-on-content-click="false">
                  <template v-slot:activator="{ props }">
                    <v-text-field
                      class="py-2 font"
                      label="Order Date"
                      prepend-icon="mdi-calendar-range"
                      :model-value="editedOrderReceipt.orderDate?.toLocaleDateString('en-GB')"
                      readonly
                      v-bind="props"
                      variant="outlined"
                      hide-details
                    ></v-text-field>
                  </template>
                  <v-date-picker
                    v-model="editedOrderReceipt.orderDate"
                    hide-actions
                    title="Please Select Order Date"
                  >
                    <template v-slot:header></template>
                  </v-date-picker>
                </v-menu>
                <v-menu v-model="isOpenReceiveDate" :close-on-content-click="false">
                  <template v-slot:activator="{ props }">
                    <v-text-field
                      class="py-2 font"
                      label="Receive Date"
                      prepend-icon="mdi-calendar-range"
                      :model-value="editedOrderReceipt.receiveDate?.toLocaleDateString('en-GB')"
                      readonly
                      v-bind="props"
                      variant="outlined"
                      hide-details
                    ></v-text-field>
                  </template>
                  <v-date-picker
                    v-model="editedOrderReceipt.receiveDate"
                    hide-actions
                    title="Please Select Receive Date"
                  >
                    <template v-slot:header></template>
                  </v-date-picker>
                </v-menu>
              </v-container>
            </div>
          </v-form>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn
            color="red"
            variant="flat"
            style="width: 150px; height: 50px"
            class="mb-3"
            @click="closeDialog"
            >Close</v-btn
          >
          <v-btn
            color="success"
            variant="flat"
            style="width: 150px; height: 50px"
            class="mb-3"
            @click="save"
            >Save</v-btn
          >
        </v-card-actions>
      </v-card>
    </v-dialog>

    <!-- dialog delete -->
    <v-dialog v-model="dialogDelete" max-width="500px">
      <v-card>
        <v-card-title class="font ma-4 pt-6" style="text-align: center"
          >you want to delete this info? 🗑️</v-card-title
        >
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn
            color="red"
            variant="flat"
            style="width: 150px; height: 50px"
            class="mb-3"
            @click="closeDelete"
            >Cancel</v-btn
          >
          <v-spacer></v-spacer>
          <v-btn
            color="success"
            variant="flat"
            style="width: 150px; height: 50px"
            class="mb-3"
            @click="deleteItemConfirm"
            >OK</v-btn
          >
          <v-spacer></v-spacer>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <!-- confirm Receive Order -->
    <v-dialog v-model="dialogReceiveOrder" max-width="500px">
      <v-card>
        <v-card-title class="font ma-4 pt-6" style="text-align: center"
          >you want to receive this order?</v-card-title
        >
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn
            color="red"
            variant="flat"
            style="width: 150px; height: 50px"
            class="mb-3"
            @click="closeReceiveOrderConfirm"
            >Cancel</v-btn
          >
          <v-spacer></v-spacer>
          <v-btn
            color="success"
            variant="flat"
            style="width: 150px; height: 50px"
            class="mb-3"
            @click="orderStockReceiveConfirm"
            >OK</v-btn
          >
          <v-spacer></v-spacer>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<style scoped>
* {
  font-family: 'Kanit';
}
</style>
